#include "p18f6722.h"
#include "timers.h"
#include "i2c.h"
#include "i2c_slave.h"
#include "LED_turret.h"

void I2C_isr(void);
void CCP1_isr(void);
void init_red_buffer(unsigned char write_buffer[]);


unsigned char last_command = 0;
unsigned char time_change_flag = 0;

#pragma code low_vector = 0x18
void low_interrupt(void)
{
	_asm GOTO CCP1_isr _endasm
}
#pragma code  // allow linker to locate remaining code

#pragma code high_vector = 0x08
void high_interrupt(void)
{
	_asm GOTO I2C_isr _endasm
}
#pragma code  // allow linker to locate remaining code

unsigned long j;

void main ()
{

	//OSCCON= 0x73; //b'01110011';
	OSCCONbits.IRCF0 = 1;
	OSCCONbits.IRCF1 = 1;
	OSCCONbits.IRCF2 = 1;
	//OSCCONbits.SCS1 = 1;
	//OSCTUNE= 0xC0; //b'11000000'
	OSCTUNEbits.PLLEN = 1;

	init_LEDturret(0xB0);		// init the turret with I2C address 0xB0

	//LED_mode = 0;

	while (1)
	{

		//LATDbits.LATD1 =0;
		//PIE1bits.SSP1IE = 0;

		// check if new command was sent through I2C, reset parameters
		if (buffer_flag[145])	
		{			
			for (j = 0; j<24; j++)
			{
				// reset all parameter values from the register buffer
				// set max_duty
				if (buffer_flag[j])
				{
					PIE1bits.SSP1IE = 0;
					max_duty[j] = buffer[j];
					PIE1bits.SSP1IE = 1;
					buffer_flag[j] = 0;
				}
			}

			// ninth led setting
			for (j = 146; j<149; j++)
			{
				// set max_duty
				if (buffer_flag[j])
				{
					PIE1bits.SSP1IE = 0;
					max_duty[j-122] = buffer[j];	// j-122 => 24, 25, 26
					PIE1bits.SSP1IE = 1;
					buffer_flag[j] = 0;
				}
			}

			for (j = 164; j<172; j++)
			{
				// set max duty
				if (buffer_flag[j])
				{
					PIE1bits.SSP1IE = 0;
					max_duty[j-137] = buffer[j];	// j-137 => 27, 28, 29, 30
					PIE1bits.SSP1IE = 1;
					buffer_flag[j] = 0;
				}				
			}

			buffer_flag[145] = 0;
		}

		//PIE1bits.SSP1IE = 1;
		//PIE1bits.SSP1IE = 0;

		for (i=0; i<35; i++) {
			PIE1bits.SSP1IE = 0;
			next_duty[i] = max_duty[i];
			PIE1bits.SSP1IE = 1;	
		}

		flag_new_cycle = 0;

		_asm NOP _endasm		// this NOP is needed to fix a bug in the compiler....do not remove
		// wait until the end of the current cycle

		while (flag_new_cycle != 1);
	}
}
