#ifndef LED_TURRET
#define LED_TURRET

#include "i2c_slave.h"
#include "p18F6722.h"

#define RED_LED_ON 0	// define the logic level to turn on the red LED
#define RED_LED_OFF 1
#define GREEN_LED_ON 0
#define GREEN_LED_OFF 1
#define BLUE_LED_ON 0
#define BLUE_LED_OFF 1
#define DEBUG_LED_ON 0
#define DEBUG_LED_OFF 1
#define IR_ON 0
#define IR_OFF 1


#pragma config WDT = OFF
#pragma config PWRT = ON
#pragma config BOREN = OFF
#pragma config OSC = INTIO67 //XT 
#pragma config LVP = OFF

#pragma udata settings_int1
// internal variables used to calculate duty cycle pulse
unsigned char current_duty[35], next_duty[35]; //, PWM_mode[35], slope_counter[35], up_mode[35], down_mode[35];
unsigned char flag_new_cycle;
#pragma code  // allow linker to locate remaining code

#pragma udata settings_int2
//unsigned char slope_increment[35], slope_decrement[35];
//unsigned int current_cycle[35];
unsigned char i, PWM_counter; //,LED_mode, debug_flag;
#pragma code  // allow linker to locate remaining code

#pragma udata settings_ext1
// user-defined settings for each LED set through I2C
unsigned char max_duty[35]; //, up_slope[35], down_slope[35];
#pragma code  // allow linker to locate remaining code

#pragma udata settings_ext2
//unsigned int on_time[35], off_time[35], period[35];
#pragma code  // allow linker to locate remaining code

unsigned char command_register;

void init_LEDturret();
//void calculate_next_PWM(unsigned char index, unsigned char period_index, unsigned char flag_increase_cycle);

// define LED pins - red
#define LEDR0 LATDbits.LATD0
#define LEDR1 LATDbits.LATD1
#define LEDR2 LATDbits.LATD2
#define LEDR3 LATDbits.LATD3
#define LEDR4 LATDbits.LATD4
#define LEDR5 LATDbits.LATD5
#define LEDR6 LATDbits.LATD6
#define LEDR7 LATDbits.LATD7
#define LEDR8 LATBbits.LATB3

// define LED pins - blue
#define LEDB0 LATEbits.LATE0
#define LEDB1 LATEbits.LATE1
#define LEDB2 LATEbits.LATE2
#define LEDB3 LATEbits.LATE3
#define LEDB4 LATEbits.LATE4
#define LEDB5 LATEbits.LATE5
#define LEDB6 LATEbits.LATE6
#define LEDB7 LATEbits.LATE7
#define LEDB8 LATBbits.LATB5

// define LED pins - green
#define LEDG0 LATFbits.LATF0
#define LEDG1 LATFbits.LATF1
#define LEDG2 LATFbits.LATF2
#define LEDG3 LATFbits.LATF3
#define LEDG4 LATFbits.LATF4
#define LEDG5 LATFbits.LATF5
#define LEDG6 LATFbits.LATF6
#define LEDG7 LATFbits.LATF7
#define LEDG8 LATBbits.LATB4

// define IR pins
#define IR0 LATAbits.LATA0
#define IR1 LATAbits.LATA1
#define IR2 LATAbits.LATA2
#define IR3 LATAbits.LATA3
#define IR4 LATGbits.LATG0
#define IR5 LATGbits.LATG1
#define IR6 LATGbits.LATG2
#define IR7 LATGbits.LATG3

// define debug LEDs
#define DEBUG0 LATBbits.LATB0
#define DEBUG1 LATBbits.LATB1
#define DEBUG2 LATBbits.LATB2

// define I2C pins
#define I2C_SDA PORTCbits.RC4
#define I2C_CLK PORTCbits.RC3

// define LED direction - red
#define LEDR0_dir TRISDbits.TRISD0
#define LEDR1_dir TRISDbits.TRISD1
#define LEDR2_dir TRISDbits.TRISD2
#define LEDR3_dir TRISDbits.TRISD3
#define LEDR4_dir TRISDbits.TRISD4
#define LEDR5_dir TRISDbits.TRISD5
#define LEDR6_dir TRISDbits.TRISD6
#define LEDR7_dir TRISDbits.TRISD7
#define LEDR8_dir TRISBbits.TRISB3

// define LED direction - blue
#define LEDB0_dir TRISEbits.TRISE0
#define LEDB1_dir TRISEbits.TRISE1
#define LEDB2_dir TRISEbits.TRISE2
#define LEDB3_dir TRISEbits.TRISE3
#define LEDB4_dir TRISEbits.TRISE4
#define LEDB5_dir TRISEbits.TRISE5
#define LEDB6_dir TRISEbits.TRISE6
#define LEDB7_dir TRISEbits.TRISE7
#define LEDB8_dir TRISBbits.TRISB5

// define LED direction - green
#define LEDG0_dir TRISFbits.TRISF0
#define LEDG1_dir TRISFbits.TRISF1
#define LEDG2_dir TRISFbits.TRISF2
#define LEDG3_dir TRISFbits.TRISF3
#define LEDG4_dir TRISFbits.TRISF4
#define LEDG5_dir TRISFbits.TRISF5
#define LEDG6_dir TRISFbits.TRISF6
#define LEDG7_dir TRISFbits.TRISF7
#define LEDG8_dir TRISBbits.TRISB4

// define IR direction
#define IR0_dir TRISAbits.TRISA0
#define IR1_dir TRISAbits.TRISA1
#define IR2_dir TRISAbits.TRISA2
#define IR3_dir TRISAbits.TRISA3
#define IR4_dir TRISGbits.TRISG0
#define IR5_dir TRISGbits.TRISG1
#define IR6_dir TRISGbits.TRISG2
#define IR7_dir TRISGbits.TRISG3

// define debug LEDs direction
#define DEBUG0_dir TRISBbits.TRISB0
#define DEBUG1_dir TRISBbits.TRISB1
#define DEBUG2_dir TRISBbits.TRISB2

// define I2C pins direction
#define I2C_SDA_dir TRISCbits.TRISC4
#define I2C_CLK_dir TRISCbits.TRISC3

// define enable LDO
#define ENABLE_LDO_dir TRISCbits.TRISC0
#define ENABLE_LDO PORTCbits.RC0

void init_LEDturret(unsigned char I2C_address)
{
	LEDR0 = RED_LED_OFF;
	LEDR1 = RED_LED_OFF;
	LEDR2 = RED_LED_OFF;
	LEDR3 = RED_LED_OFF;
	LEDR4 = RED_LED_OFF;
	LEDR5 = RED_LED_OFF;
	LEDR6 = RED_LED_OFF;
	LEDR7 = RED_LED_OFF;
	LEDR8 = RED_LED_OFF;
	LEDB0 = BLUE_LED_OFF;
	LEDB1 = BLUE_LED_OFF;
	LEDB2 = BLUE_LED_OFF;
	LEDB3 = BLUE_LED_OFF;
	LEDB4 = BLUE_LED_OFF;
	LEDB5 = BLUE_LED_OFF;
	LEDB6 = BLUE_LED_OFF;
	LEDB7 = BLUE_LED_OFF;
	LEDB8 = BLUE_LED_OFF;
	LEDG0 = GREEN_LED_OFF;
	LEDG1 = GREEN_LED_OFF;
	LEDG2 = GREEN_LED_OFF;
	LEDG3 = GREEN_LED_OFF;
	LEDG4 = GREEN_LED_OFF;
	LEDG5 = GREEN_LED_OFF;
	LEDG6 = GREEN_LED_OFF;
	LEDG7 = GREEN_LED_ON;
	LEDG8 = GREEN_LED_ON;

	IR0 = IR_OFF;
	IR1 = IR_OFF;
	IR2 = IR_OFF;
	IR3 = IR_OFF;
	IR4 = IR_OFF;
	IR5 = IR_OFF;
	IR6 = IR_OFF;
	IR7 = IR_OFF;

	DEBUG0 = DEBUG_LED_OFF;
	DEBUG1 = DEBUG_LED_OFF;
	DEBUG2 = DEBUG_LED_OFF;
		
	LEDR0_dir = 0;
	LEDR1_dir = 0;
	LEDR2_dir = 0;
	LEDR3_dir = 0;
	LEDR4_dir = 0;
	LEDR5_dir = 0;
	LEDR6_dir = 0;
	LEDR7_dir = 0;
	LEDR8_dir = 0;
	LEDB0_dir = 0;
	LEDB1_dir = 0;
	LEDB2_dir = 0;
	LEDB3_dir = 0;
	LEDB4_dir = 0;
	LEDB5_dir = 0;
	LEDB6_dir = 0;
	LEDB7_dir = 0;
	LEDB8_dir = 0;
	LEDG0_dir = 0;
	LEDG1_dir = 0;
	LEDG2_dir = 0;
	LEDG3_dir = 0;
	LEDG4_dir = 0;
	LEDG5_dir = 0;
	LEDG6_dir = 0;
	LEDG7_dir = 0;
	LEDG8_dir = 0;

	IR0_dir = 0;
	IR1_dir = 0;
	IR2_dir = 0;
	IR3_dir = 0;
	IR4_dir = 0;
	IR5_dir = 0;
	IR6_dir = 0;
	IR7_dir = 0;

	DEBUG0_dir = 0;
	DEBUG1_dir = 0;
	DEBUG2_dir = 0;
	
	// define I2C pins as inputs
	I2C_SDA = 1;
	I2C_CLK = 1;
	
	ENABLE_LDO_dir = 0;
	ENABLE_LDO = 1;

	// ----- clear command buffer (for commands received from e-Puck) -----
	for (i=0; i<BUFFER_SIZE; i++) {
		buffer[i] = 0;
		buffer_flag[i] = 0; }

	// ----- clear all internal and external parameters
	for (i=0; i<35; i++)
	{
		// external parameters
		max_duty[i] = 0;
		//up_slope[i] = 0;
		//down_slope[i] = 0;;
		//on_time[i] = 0;
		//off_time[i] = 0;
		//period[i] = 0;;
		
		// internal parameters
		current_duty[i] = 0;
		next_duty[i] = 0;
		//PWM_mode[i] = 0;
		//slope_counter[i] = 0;
		//up_mode[i] = 0;
		//down_mode[i] = 0;
		//slope_increment[i] = 0;
		//slope_decrement[i] = 0;
		//current_cycle[i] = 0;
	}

	// ----- initialise I2C interface with e-Puck
	init_I2C(I2C_address);

	// ----- start timer0 as time base for CCP module ------
	OpenTimer1(TIMER_INT_ON &		// interrupt enabled
			T1_8BIT_RW &			// 8-bit timer read/write
			T1_SOURCE_INT &			// Internal clock source (Tosc)
			T1_OSC1EN_OFF &			// T1 oscillator off
			T1_PS_1_1)	;		// 1:1 prescale

	// ----- set CCP special event trigger (used to generate PWMs) ------
	CCPR1L = 0x20;			// set CCP interrupt every 300 instructions (118 us), for 7bit resolution, gives 128*118~=0.0151sec period, 66Hz
	CCPR1H = 0x03;
	T3CONbits.T3CCP1 = 0;  // set timer3 as the clock source for CCP1-5
	T3CONbits.T3CCP2 = 0;
	PIR1bits.CCP1IF = 0;	// clear CCP1 interrupt flag
	PIE1bits.CCP1IE = 1;	// enable CCP1 interrupt
	IPR1bits.CCP1IP = 0;	// set LOW PRIORITY for CCP1
	TRISCbits.TRISC2 = 0;	// set CCP1 pin as output
	CCP1CON = 0x0B;		// set CCP1 mode to compare, special event trigger



}

/* drop each LED PWM pulse when the desired duty cycle is reached */
#pragma interrupt CCP1_isr
void CCP1_isr(void)  // interrupt for PWM generation
{
	// check if the end of current PWM cycle has been reached
	if (PWM_counter == 128)
	{
		// a new cycle has been started, reset PWM values for this cycle
		for (i=0; i<35; i++)
			current_duty[i] = next_duty[i];
		PWM_counter = 0;

		// set all to 1, even if they are supposed to be 0...shouldn't be noticeable to the eye, and decreases processing requirements of this step
		if (current_duty[0] != 0)
			LEDR0 = RED_LED_ON;
		if (current_duty[1] != 0)
			LEDR1 = RED_LED_ON;
		if (current_duty[2] != 0)
			LEDR2 = RED_LED_ON;
		if (current_duty[3] != 0)
			LEDR3 = RED_LED_ON;
		if (current_duty[4] != 0)
			LEDR4 = RED_LED_ON;
		if (current_duty[5] != 0)
			LEDR5 = RED_LED_ON;
		if (current_duty[6] != 0)
			LEDR6 = RED_LED_ON;
		if (current_duty[7] != 0)
			LEDR7 = RED_LED_ON;
		if (current_duty[8] != 0)
			LEDB0 = BLUE_LED_ON;
		if (current_duty[9] != 0)
			LEDB1 = BLUE_LED_ON;
		if (current_duty[10] != 0)
			LEDB2 = BLUE_LED_ON;
		if (current_duty[11] != 0)
			LEDB3 = BLUE_LED_ON;
		if (current_duty[12] != 0)
			LEDB4 = BLUE_LED_ON;
		if (current_duty[13] != 0)
			LEDB5 = BLUE_LED_ON;
		if (current_duty[14] != 0)
			LEDB6 = BLUE_LED_ON;
		if (current_duty[15] != 0)
			LEDB7 = BLUE_LED_ON;
		if (current_duty[16] != 0)
			LEDG0 = GREEN_LED_ON;
		if (current_duty[17] != 0)
			LEDG1 = GREEN_LED_ON;
		if (current_duty[18] != 0)
			LEDG2 = GREEN_LED_ON;
		if (current_duty[19] != 0)
			LEDG3 = GREEN_LED_ON;
		if (current_duty[20] != 0)
			LEDG4 = GREEN_LED_ON;
		if (current_duty[21] != 0)
			LEDG5 = GREEN_LED_ON;
		if (current_duty[22] != 0)
			LEDG6 = GREEN_LED_ON;
		if (current_duty[23] != 0)
			LEDG7 = GREEN_LED_ON;
		if (current_duty[24] != 0)
			LEDR8 = RED_LED_ON;
		if (current_duty[25] != 0)
			LEDB8 = BLUE_LED_ON;
		if (current_duty[26] != 0)
			LEDG8 = GREEN_LED_ON;
		if (current_duty[27] != 0)
			IR0 = IR_ON;
		if (current_duty[28] != 0)
			IR1 = IR_ON;
		if (current_duty[29] != 0)
			IR2 = IR_ON;
		if (current_duty[30] != 0)
			IR3 = IR_ON;
		if (current_duty[31] != 0)
			IR4 = IR_ON;
		if (current_duty[32] != 0)
			IR5 = IR_ON;
		if (current_duty[33] != 0)
			IR6 = IR_ON;
		if (current_duty[34] != 0)
			IR7 = IR_ON;
		// indicate that a new cycle has begun, start calculations over again
		flag_new_cycle = 1;
	}
	
	// check if duty cycle reached
	if (current_duty[0] == PWM_counter)
		LEDR0 = RED_LED_OFF;
	if (current_duty[1] == PWM_counter)
		LEDR1 = RED_LED_OFF;
	if (current_duty[2] == PWM_counter)
		LEDR2 = RED_LED_OFF;
	if (current_duty[3] == PWM_counter)
		LEDR3 = RED_LED_OFF;
	if (current_duty[4] == PWM_counter)
		LEDR4 = RED_LED_OFF;
	if (current_duty[5] == PWM_counter)
		LEDR5 = RED_LED_OFF;
	if (current_duty[6] == PWM_counter)
		LEDR6 = RED_LED_OFF;
	if (current_duty[7] == PWM_counter)
		LEDR7 = RED_LED_OFF;
	if (current_duty[8] == PWM_counter)
		LEDB0 = BLUE_LED_OFF;
	if (current_duty[9] == PWM_counter)
		LEDB1 = BLUE_LED_OFF;
	if (current_duty[10] == PWM_counter)
		LEDB2 = BLUE_LED_OFF;
	if (current_duty[11] == PWM_counter)
		LEDB3 = BLUE_LED_OFF;
	if (current_duty[12] == PWM_counter)
		LEDB4 = BLUE_LED_OFF;
	if (current_duty[13] == PWM_counter)
		LEDB5 = BLUE_LED_OFF;
	if (current_duty[14] == PWM_counter)
		LEDB6 = BLUE_LED_OFF;
	if (current_duty[15] == PWM_counter)
		LEDB7 = BLUE_LED_OFF;
	if (current_duty[16] == PWM_counter)
		LEDG0 = GREEN_LED_OFF;
	if (current_duty[17] == PWM_counter)
		LEDG1 = GREEN_LED_OFF;
	if (current_duty[18] == PWM_counter)
		LEDG2 = GREEN_LED_OFF;
	if (current_duty[19] == PWM_counter)
		LEDG3 = GREEN_LED_OFF;
	if (current_duty[20] == PWM_counter)
		LEDG4 = GREEN_LED_OFF;
	if (current_duty[21] == PWM_counter)
		LEDG5 = GREEN_LED_OFF;
	if (current_duty[22] == PWM_counter)
		LEDG6 = GREEN_LED_OFF;
	if (current_duty[23] == PWM_counter)
		LEDG7 = GREEN_LED_OFF;
	if (current_duty[24] == PWM_counter)
		LEDR8 = RED_LED_OFF;
	if (current_duty[25] == PWM_counter)
		LEDB8 = BLUE_LED_OFF;
	if (current_duty[26] == PWM_counter)
		LEDG8 = GREEN_LED_OFF;
	if (current_duty[27] == PWM_counter)
		IR0 = IR_OFF;
	if (current_duty[28] == PWM_counter)
		IR1 = IR_OFF;
	if (current_duty[29] == PWM_counter)
		IR2 = IR_OFF;
	if (current_duty[30] == PWM_counter)
		IR3 = IR_OFF;
	if (current_duty[31] == PWM_counter)
		IR4 = IR_OFF;
	if (current_duty[32] == PWM_counter)
		IR5 = IR_OFF;
	if (current_duty[33] == PWM_counter)
		IR6 = IR_OFF;
	if (current_duty[34] == PWM_counter)
		IR7 = IR_OFF;
	PWM_counter++;
  	PIR1bits.CCP1IF = 0;            // clear interrupt flag
}
#pragma code  // allow linker to locate remaining code

/*
void calculate_next_PWM(unsigned char index, unsigned char period_index, unsigned char flag_increase_cycle)
{
	// if on and off times are the same, keep the led at max brightness defined by max_duty[index]	
	if (on_time[index] == off_time[index])
		PWM_mode[index] = 4;
	// if period is 0, there is no blinking, keep the led at max brightness defined by max_duty[index]
	if (period[period_index] == 0)
		PWM_mode[index] = 4;
	if (max_duty[index] == 0)
		PWM_mode[index] = 4;

	// calculate the next PWM duty cycle for each LED
	switch (PWM_mode[index]) {
	case 0:  // LED is currently OFF
	{
		if (current_cycle[period_index] == on_time[index])		// it's time to start increasing the PWM
		{
			slope_counter[index] = 0;				// start slope counter (in case it's a slow slope)
			PWM_mode[index] = 1;						// switch to UP mode
		}
		break;
	}
	case 1:	// LED PWM is increasing (going UP)
	{
		if (up_mode[index] == 0)					// slow slope - use counter mode
		{
			if (slope_counter[index] == slope_increment[index])	// it's time to increase
			{
				next_duty[index]++;
				slope_counter[index] = 0;
			}
			else
				slope_counter[index]++;
		}
		else									// fast slope - use increment mode
			next_duty[index] += slope_increment[index];
		
		if (next_duty[index] >= max_duty[index])		// the maximum duty as been reached
		{
			next_duty[index] = max_duty[index];
			PWM_mode[index] = 2;						// switch to ON mode
		}
		
		if (current_cycle[period_index] == off_time[index])		// off time was reached before maximum duty
			PWM_mode[index] = 3;						// switch to DOWN mode

		break;
	}
	case 2:	// LED is currently at maximum brightness (ON)
	{
		if (current_cycle[period_index] == off_time[index])	// it's time to start decreasing the PWN
		{
			slope_counter[index] = 0;				// start slope counter (in case it's a slow slope)
			PWM_mode[index] = 3;						// switch to DOWN mode
		}
		break;
	}
	case 3: // LED PWM is decreasing (going DOWN)
	{		
		if (down_mode[index] == 0)					// slow slope - use counter mode
		{
			if (slope_counter[index] == slope_decrement[index])	// it's time to decrease
			{
				if (next_duty[index] == 0)				// the minimum duty as been reached
					PWM_mode[index] = 0;					// switch to OFF mode
				else
					next_duty[index]--;
				slope_counter[index] = 0;
			}
			else
				slope_counter[index]++;
		}
		else									// fast slope - use decrement mode
		{
			if (next_duty[index] > slope_decrement[index])
				next_duty[index] -= slope_decrement[index];
			else								// reached the end of the slope
			{
				next_duty[index] = 0;
				PWM_mode[index] = 0;					// switch to OFF mode
			}
		}
		
		if (current_cycle[period_index] == on_time[index])		// on time was reached before 0% duty
		{
			next_duty[index] = 0;						// start climbing again from 0
			PWM_mode[index] = 1;						// switch to UP mode
		}
					
		break;
	}		
	case 4:		// on_time is same as off_time, or period = 0, keep at max brightness
	{
		PIE1bits.SSP1IE = 0;
		next_duty[index] = max_duty[index];
		PIE1bits.SSP1IE = 1;
		if (on_time[index] != off_time[index])	// check if parameters have changed
			PWM_mode[index] = 0;
		else if (period[period_index] != 0)
			PWM_mode[index] = 0;		
		else if (max_duty[index] != 0)
			PWM_mode[index] = 0;				
	}
	default:	// parameters were changed, reset the LED
	{
		PWM_mode[index] = 0;
	}
	}

	if (flag_increase_cycle)
	{
		if (current_cycle[period_index] >= period[period_index])			// reset cycle when end of period is reached
			current_cycle[period_index] = 0;
		else
			current_cycle[period_index]++;
	}
}
*/
#endif

